<script>
import Vue from 'vue';

export default Vue.extend({
  name: 'KubeconSection',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    hasGradient: {
      type: Boolean,
      required: false,
      default: false,
    },
    hasDarkBackground: {
      type: Boolean,
      required: false,
      default: false,
    },
    offsetImage: {
      type: Number,
      required: false,
      default: 0,
    },
  },
  computed: {
    getPageName() {
      return this.$parent.content.slug;
    },
    cssImageProps() {
      return {
        '--margin-top': `${this.offsetImage}px`,
      };
    },
  },
});
</script>

<template>
  <div
    class="slp-py-96"
    :class="
      hasDarkBackground
        ? 'kubecon-section__dark'
        : hasGradient
        ? 'kubecon-section'
        : ''
    "
  >
    <SlpContainer>
      <SlpRow>
        <SlpColumn
          :cols="6"
          class="slp-pr-lg-16"
          :class="hasDarkBackground ? 'kubecon-section__dark-text' : ''"
        >
          <img
            v-if="data.icon"
            :src="`/nuxt-images/icons/events/${data.icon}`"
            alt=""
            class="slp-mb-8"
          />
          <SlpTypography
            v-if="data.title"
            :variant="hasGradient ? 'heading2-bold' : 'heading4-bold'"
            tag="h3"
            class="slp-pb-24"
          >
            {{ data.title }}
          </SlpTypography>
          <div v-for="(item, index) in data.subheadings" :key="index">
            <SlpTypography variant="body1-bold">
              {{ item.title }}:
            </SlpTypography>
            <SlpTypography variant="body1">
              {{ item.value }}
            </SlpTypography>
          </div>
          <SlpTypography variant="body1" tag="p" class="slp-py-24">{{
            data.information
          }}</SlpTypography>
          <SlpButton
            v-if="data.call_to_action"
            :href="data.call_to_action.button_link"
            class="slp-mb-48"
            :variant="hasDarkBackground ? 'secondary' : 'primary'"
            >{{ data.call_to_action.button_text }}</SlpButton
          >
        </SlpColumn>
        <SlpColumn v-if="hasGradient" :cols="1" />
        <SlpColumn :cols="hasGradient ? 5 : 6" style="align-self: center">
          <nuxt-img
            class="kubecon-section__img"
            :class="offsetImage ? 'kubecon-section__img--offset' : ''"
            :src="`/nuxt-images/events/${getPageName}/${data.image.src}`"
            :alt="data.image.alt"
            :style="cssImageProps"
          />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.kubecon-section {
  background: linear-gradient(
    165.41deg,
    #fadcd7 0%,
    #f8f5ff 23.65%,
    #ffffff 54.66%,
    #f6f3fe 80.95%,
    #ffd4d8 100.92%
  );

  &__dark {
    background: #171321;

    &-text {
      color: #ffffff;
    }
  }

  &__img {
    max-width: 100%;
    @media screen and (max-width: $breakpoint-sm) {
      margin-bottom: 64px;
    }

    @media screen and (min-width: $breakpoint-md) {
      &--offset {
        position: relative;
        margin-top: var(--margin-top);
      }
    }
  }
}
</style>
